#include "typedef.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "object.h"
#include "edge.h"

extern int	readclassfile(char *pathP, int silent);
extern void pseudo_source(void);
extern void	emitta(void);

int		g_dynamic     = 0;
int		g_verbose     = 0;
int		g_variables   = 0;
int		g_fields      = 0;
int     g_subclass_permissions = 0;
int		g_zero_indirections    = 0;
char	*g_classpathP = 0;
char	*g_java[10]	  = {0,"-g","-classpath", ".", 0, 0};
char	**g_envPP;
int		g_access_used[8] = {0, 0, 0, 0, 0, 0, 0, 0};

/* 0 - edge enabled by default
   1 - edges are permanently disabled
   2 - edge enabled by -l
   3 - edge enabled by -f
 */

int		g_hide_edges[NUMBER_EDGE_TYPES] = {
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/*   9 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/*  19 */
	1, 2, 2, 2, 2, 2, 1, 1, 1, 1,	/*  29 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/*  39 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/*  49 */
	1, 1, 1, 1, 2, 2, 2, 2, 2, 1,	/*  59 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/*  69 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/*  79 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/*  89 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/*  99 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/* 109 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/* 119 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/* 129 */
	1, 1, 2, 1, 1, 1, 1, 1, 1, 1,	/* 139 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/* 149 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/* 159 */
	1, 1, 1, 1, 1, 1, 1, 1, 2, 2,	/* 169 */
	1, 1, 1, 1, 1, 1, 1, 1, 3, 3,	/* 179 */
	3, 3, 0, 0, 0, 0, 1, 0, 1, 0,	/* 189 */
	1, 1, 0, 0, 1, 1, 1, 0, 1, 1,	/* 199 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 2,	/* 209 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/* 219 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/* 229 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/* 239 */
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1,	/* 249 */
	1, 1, 1, 1, 1, 1, 0, 0, 0, 0,	/* 259 */
	0, 0, 0, 0
};

int
main(int argc, char *argv[], char *env[])
{
	char		*filenamesP = 0;
	FILE		*F;
	char		*P, *P1;
	int			i, j, edge_type;
	
	printf("// Javex Version 1.0.5 Compiled " __DATE__ ":"  __TIME__ "\n");
	printf("// Arguments to %s:\n", argv[0]);

	g_envPP = env;

	for (i = 1; i < argc;) {
		P = argv[i++];
		if (*P == '-') {
			fprintf(stdout,"// %s", P);
			switch (P[1]) {
			case 'c':
				if (g_classpathP) {
					fprintf(stderr, "-c option may only be specified once\n");
					return(1);
				}
				if (i < argc) {
					g_classpathP = argv[i++];
					g_java[3]    = g_classpathP;
					fputc(' ', stdout);
					fputs(g_classpathP, stdout);
				}
				break;
			case 'd':
				g_dynamic = 1;
				break;
			case 'e':
				if (i < argc) {
					P1        = argv[i++];
					edge_type = atoi(P1);
					fputc(' ', stdout);
					fputs(P1, stdout);
					if (edge_type > 0 && edge_type < NUMBER_EDGE_TYPES) {
						if (g_hide_edges[edge_type]) {
							fputs(" [useless]", stdout);
						}
						g_hide_edges[edge_type] = 1;
					} else {
						fputs(" [invalid]", stdout);
				}	}
				break;
			case 'f':
				g_fields = 1;
				for (j = 0; j < NUMBER_EDGE_TYPES; ++j) {
					if (g_hide_edges[j] == 3) {
						g_hide_edges[j] = 0;
				}	}
				break;
			case 'i':
				if (filenamesP) {
					fprintf(stderr, "-i option may only be specified once\n");
					return(1);
				}
				if (i >= argc) {
					filenamesP = "-";
				} else {
					filenamesP = argv[i++];
				}
				fputc(' ', stdout);
				fputs(filenamesP, stdout);
				break;
			case 'j':
				if (i < argc) {
					if (g_java[0]) {
						fprintf(stderr, "-i option may only be specified once\n");
						return(1);
					}
					g_java[0] = P1 = argv[i++];
					fputc(' ', stdout);
					fputs(P1, stdout);
				}
				break;;
			case 'l':
				g_variables = 1;
				for (j = 0; j < NUMBER_EDGE_TYPES; ++j) {
					if (g_hide_edges[j] == 2) {
						g_hide_edges[j] = 0;
				}	}
				break;
			case 'p':
				if (g_subclass_permissions) {
					for (j = 0; j < 8; ++j) {
						g_access_used[j] = 1;
				}	}
				++g_subclass_permissions;
				break;
			case 'v':
				g_verbose = 1;
				break;
			case 'z':
				g_zero_indirections = 1;
				break;
			default:
				fputs("Options:\n", stderr);
				fputs("  -j/ava <program>\n", stderr);
				fputs("  -c/lasspath <paths>\n", stderr);
				fputs("  -i/nput filenames\n", stderr);
				fputs("  -d/ynamic\n", stderr);
				fputs(" [-e/dge number]*\n", stderr);
				fputs("  -f/ields\n", stderr);
				fputs("  -l/ocals\n", stderr);
				fputs("  -v/erbose\n", stderr);
				fputs("  -p/ermissions\n", stderr);
				fputs("  -z/ero\n", stderr);
				return(1);
			}
			fputc('\n', stdout);
			continue;
		}

		readclassfile(P, 0);
	}
	fputc('\n', stdout);
	
	if (filenamesP) {
		char	filename[2048];
		char	*P;
		int		c;

		if (!strcmp(filenamesP, "-")) {
			F = stdin;
		} else {
			F = fopen(filenamesP, "r");
			if (!F) {
				fprintf(stderr, "Couldn't open %s\n", filenamesP);
				return(1);
		}	}
		do {
			P = filename;
			for (;;) {
				c = getc(F);
				if (c == '\r' || c == '\n' || c == EOF) {
					break;
				}
				*P++ = c;
			}
			if (P != filename) {
				*P = 0;
				readclassfile(filename, 0);
			}
		} while (c != EOF);

		if (F != stdin) {
			fclose(F);
	}	}
	pseudo_source();
	emitta();
	return(0);
}

