#if defined(WIN32)
typedef unsigned char		u1T;
typedef unsigned short		u2T;
typedef unsigned __int32	u4T;
typedef signed   __int32	s4T;
typedef unsigned __int64	u8T;
#else
typedef unsigned char		u1T;
typedef unsigned short		u2T;
typedef unsigned int		u4T;
typedef signed int			s4T;
typedef unsigned long long	u8T;
#endif


typedef enum {
	entityE    = 0,	
	directoryE = 1,
	sourceE    = 2,
	functionE  = 3,
	variableE  = 4,
	fieldE     = 5,
	arrayE     = 6,
	edgeE      = 7,
	classE     = 8
} objectE;

class Cobject {
public:
	static Cobject	*g_created_headP;
	static Cobject	*g_created_tailP;

	Cobject			*m_created_nextP;		/* List in the order created */

	Cobject(void);

	void add_created(void);

	virtual void 	emit_id(void) const   = 0;
	virtual objectE	type(void) const      = 0;
	virtual void	emit_edges(void)      = 0;
	virtual void	emit_attributes(void) const = 0;
};

class Centity : public Cobject {
public:
	Centity	*m_parentP;

	Centity(void);

	virtual void	emit_edges(void);
	virtual size_t	full_path(char *bufferP) const;
};

